/* -*- Mode: C; c-basic-offset:4 ; -*- */
/*
 *  (C) 2008 by Argonne National Laboratory.
 *      See COPYRIGHT in top-level directory.
 */

#ifndef RMKI_H_INCLUDED
#define RMKI_H_INCLUDED

#include "hydra.h"

struct HYD_RMKI_fns {
    HYD_Status(*query_node_list) (int num_nodes, struct HYD_Partition **partition_list);
};

extern struct HYD_RMKI_fns HYD_RMKI_fns;

HYD_Status HYD_RMKI_init(char *rmk);

/* Non-zero nodes means that the RMK should allocate the nodes if needed */
HYD_Status HYD_RMKI_query_node_list(int num_nodes, struct HYD_Partition **partition_list);

/* Each resource management kernel has to expose an initialization function */

HYD_Status HYD_RMKI_dummy_init(void);

#endif /* RMKI_H_INCLUDED */
